#include "cstool/collider.h"
#include "ivaria/collider.h"

class Demo1;

class CollisionDetection{

private:

	// Define the player bounding box.
	// The camera's lens or person's eye is assumed to be
	// at 0,0,0.  The height (DY), width (DX) and depth (DZ).
	// Is the size of the camera/person and the origin
	// coordinates (OX,OY,OZ) locate the bbox with respect to the eye.
	// This player is 1.8 metres tall (assuming 1cs unit = 1m) (6feet)

	const float DX;		//body_width;
	const float DY;		//body_height;
	const float DZ;		//body_depth;
	const float OY;		//eye_offset;
	
	const float DX_L;		//legs_width;
	const float DZ_L;		//legs_depth;
	
	const float DX_2;		//(DX/2);
	const float DZ_2;		//(DZ/2);
	
	const float DX_2L;		//(DX_L/2);
	const float DZ_2L;		//(DZ_L/2);
	
	const float OYL;		//legs_offset;
	const float DYL;		//(OY-OYL);

	//const int MAXSECTORSOCCUPIED;

	//csVector3 velocity;



	bool do_gravity;
	bool move_3d;
	bool on_ground;

	csCollisionPair our_cd_contact[1000];
	int num_our_cd;

	Demo1* app;
	
	csRef<iMeshWrapper> plbody, pllegs; // Player's body (as a 3D model) and legs
	
	// Colliders for "legs" and "body". Intersections are handled differently.
	csColliderWrapper *legs;	
	csColliderWrapper *body;
	csVector3 body_radius, body_center, legs_radius, legs_center;  
	// Collision detection plugin.
	csRef<iCollideSystem> collide_system;
	bool do_cd; // Do collisiondetection
	

public:
	CollisionDetection (Demo1* app);
	~CollisionDetection();
	void CreateColliders();
	int FindIntersection(csCollisionPair& cd,csVector3 line[2]);
	int CollisionDetect (iEngine* Engine, csColliderWrapper *c, iSector* sp, csReversibleTransform *cdt);
	int FindSectors (csVector3 v, csVector3 d, iSector *s, iSector **sa);
	void DoGravity (iEngine* Engine, csVector3& pos, csVector3& vel);
	void InitCollDet (iEngine* engine, iRegion* region);

};
