struct iEngine;
struct iLoader;
struct iGraphics3D;
struct iKeyboardDriver;
struct iVirtualClock;
struct iObjectRegistry;
struct iEvent;
struct iSector;
struct iView;
struct iFont;

class CollisionDetection;

class Demo1 {

private:
	iSector* room;
	csRef<iLoader> loader;
	csRef<iGraphics3D> g3d;
	csRef<iGraphics2D> g2d; 
	csRef<iKeyboardDriver> kbd;
	csRef<iVirtualClock> vc;
	csRef<iMeshWrapper> ball;
	csRef<iMaterial> l_mat;
	csRef<iMaterialWrapper> mw;
	csRef<iMeshWrapper> sprite;
	csVector3 newPosition;
	csVector3 lastPosition;
	csVector3 rotate;	
	float speed;
	float rotateSpeed;
	bool forcesOn;

	float frames;
	float startTime;
	bool started;

public:
	bool validConstruction;
	bool pressed;
	float tiltAngle;
	char* map_dir;
	CollisionDetection* colldet;
	csVector3 velocity;
	csRef<iPhantom> phantom;
	csRef<iEngine> engine;
	csRef<iView> view;
	iObjectRegistry* object_reg;

	Demo1(iObjectRegistry* object_reg);
	~Demo1();

	void setWorkspacePosition(double x,double y,double z);
	void SetupFrame ();
	void FinishFrame ();
	void updatePhantomFrame();
	void updateKeyboardFrame();
	bool HandleEvent (iEvent& ev);
	static bool SimpleEventHandler (iEvent& ev);
	bool Initialize(int argc, char* argv[]);
	void Start();
	bool LoadMap();
};


