struct iEngine;
struct iLoader;
struct iGraphics3D;
struct iKeyboardDriver;
struct iVirtualClock;
struct iObjectRegistry;
struct iEvent;
struct iSector;
struct iView;

class Demo2 {

private:
	iObjectRegistry* object_reg;
	iSector* room;
	csRef<iLoader> loader;
	csRef<iEngine> engine;
	csRef<iGraphics3D> g3d;
	csRef<iGraphics2D> g2d;
	csRef<iKeyboardDriver> kbd;
	csRef<iVirtualClock> vc;
	csRef<iView> view;
	csRef<iMeshWrapper> ball;
	csRef<iMaterial> l_mat;
	csRef<iMaterialWrapper> mw1;
	csRef<iMaterialWrapper> mw2;
	csRef<iMeshWrapper> sprite1;
	csRef<iMeshWrapper> sprite2;
	csRef<iMeshWrapper> sprite3;
	csRef<iDynamics> dyn;
	csRef<iDynamicSystem> dynSys;
	csRef<iRigidBody> rbSprite1;
	csRef<iRigidBody> rbSprite2;
	csRef<iRigidBody> rbSprite3;
	csRef<iRigidBody> rbSphere;
	csRef<iTextureWrapper> spheretxt;
	std::vector<csRef<iRigidBody> > rigidBodies;
	std::vector<std::pair<int,csVector3> > startPositions;
	bool firstTimeSwitch;
	csVector3 stylusDistance;
	double minX;
	double maxX;
	double minZ;
	double maxZ;
	csVector3 cameraStartPosition;
	csVector3 goalPosition;
	bool firstTime;
	float startTime;
	float stopTime;
	csRef<iFont> Font;
	csSimplePixmap* startScreen;
	csSimplePixmap* gameOverScreen;
	csSimplePixmap* gameWonScreen;
	int mode;
	int levelToPlay;
	int frames;
	bool workspaceRotated;
	bool cmdLevel;


public:
	char* map_dir;
	csRef<iPhantom> phantom;
	Demo2(iObjectRegistry* object_reg);
	~Demo2();
	void SetupFrame ();
	void FinishFrame ();
	void updatePhantomFrame();
	void CreateRigidBodies(); 
	bool HandleEvent (iEvent& ev);
	static bool SimpleEventHandler (iEvent& ev);
	bool Initialize();
	void Start();
	bool LoadMap(int level);
	void GfxWrite (int x, int y, int fg, int bg, char *str, ...);
	void Create2DImages(void);
	bool useMap;
	double posX;
	double step;
	bool validConstruction;
	csVector3 lastPhantomPosition;
	void startFrame();
	void gameOverFrame();
	void gameWonFrame();
	bool loadLevel(int level);
	void ClearLevel();

};